function HPI(only_runtime, printing_option, NITER_LATITUDE_PRINT)
% The data is available at 
% https://data.gov.uk/dataset/land-registry-house-price-index-background-tables/resource/a62c0b28-b30c-48fd-8dfd-a03e0c322a01

% Stats:
% 253x178
% k = 15
% Cancer cycles: 40

% 1) Cancer
% 2) Capricorn
% 3) NMF (snmf by Hoyer)
% 4) NMF (ALS with reg 0)
% 5) NMF (ALS with reg 1)
% 6) SVD

LAT_ITERS = 100;

%% What algorithms to run.
runCan = 1;
runCap = 0;
runSnmf = 0;
runAls = 0;
runAlsr = 0;
runSvd = 1;
runCanKL = 0;
runNmfKL = 0;
runNmfJS = 0;
runCanJS = 0;
runLat = 1;
runNMF = 1;
runLatTrunk = 1;

dataName = './data/real/HPITables4.mat';
fileName = './results/real/HPI';
experName = 'HPI';

%% Load data and preprocess.
load(dataName);
A = HPITables4;
A(:, 129) = [];
A = bsxfun(@rdivide, A, std(A));
A = bsxfun(@minus, A, min(A));

CANCER_CYCLES = 40;
k = 15;

realWorldExecute(runCan, runCanKL, runCap, runSnmf, runAls, runAlsr, ...
    runSvd, runNmfKL, A, k, CANCER_CYCLES, fileName, experName, runLat, runNMF, runLatTrunk, ...
    'runNmfJS', runNmfJS, 'runCanJS', runCanJS, 'LAT_ITERS', LAT_ITERS, 'only_runtime', only_runtime, ...
    'printing_option', printing_option, 'NITER_LATITUDE_PRINT', NITER_LATITUDE_PRINT);

end