function A = YaleLeft(varargin)
% Selects 222 images with lighting from the left from the database. 
% For each subject there are overall 64 images, the first half with the
% light source on the left. We discard the first few pictures as they are
% too dark and are left with 23 "good" images. Select images with indices
% starting from 7 and stepsize 23/npics for each subject.

%% Head
if nargin == 1
    npics = varargin{1};
else
    npics = 7; % Number of images to select for each subject. 
end

 nleft = 23; % Number of images "good" of each subject with lighting from the left.
%%

step = ceil(nleft/ npics);
imgsperperson = 64;
initial = 0;
A = Yale_matrix();
n = size(A, 2);
idx = initial : imgsperperson : n - imgsperperson;
left = 7 : step : nleft + 6;  % The first 6 images are too dark.
idx_ = zeros(numel(idx*numel(left)), 1);
count = 1;
for i = 1 : numel(idx)
    for j = 1 : numel(left)
        idx_(count) = idx(i) + left(j);
        count = count + 1;
    end
end

idx_ = sort(idx_);
A = A(:, idx_);

end

