function A = YaleRight(varargin)
% Selects 296 images with lighting from the right from the database. 
% For each subject there are overall 64 images, the second half with the
% light source on the right. We discard the last few pictures as they are
% too dark and are left with 23 "good" images. Select images with indices
% starting from 38 and stepsize 23/npics for each subject.
%% Head
if nargin == 1
    npics = varargin{1};
else
    npics = 7; % Number of images to select for each subject. 
end

 nright = 23; % Number of "good" images of each subject with lighting from the right.
%%

step = floor(nright/ npics);
imgsperperson = 64;
initial = 0;
A = Yale_matrix();
n = size(A, 2);
idx = initial : imgsperperson : n - imgsperperson;
right = 38 : step : nright + 37;
idx_ = zeros(numel(idx*numel(right)), 1);
count = 1;
for i = 1 : numel(idx)
    for j = 1 : numel(right)
        idx_(count) = idx(i) + right(j);
        count = count + 1;
    end
end

idx_ = sort(idx_);
A = A(:, idx_);

end

