function news(only_runtime, printing_option, NITER_LATITUDE_PRINT)
% Stats:
% 400x800
% k = 10
% Cancer cycles: 40

% 1) Cancer
% 2) Capricorn
% 3) NMF (snmf by Hoyer)
% 4) NMF (ALS with reg 0)
% 5) NMF (ALS with reg 1)
% 6) SVD

LAT_ITERS = 100;

%% What algorithms to run.
runCan = 1;
runCap = 0;
runSnmf = 0;
runAls = 0;
runAlsr = 0;
runSvd = 0;
runCanKL = 0;
runNmfKL = 0;
runNmfJS = 0;
runCanJS = 0;
runLat = 1;
runNMF = 1;
runLatTrunk = 1;

dataName = './data/real/news.mat';
fileName = './results/real/news';
experName = '4News';

%% Load data.
load(dataName);

%% Convert to tf-idf format and and save input data.
TF = A;
[N, M] = size(A);
H = double(A>0);
E = sum(H, 1);  % #documents containing a term
IDF = log(N./E);
A = bsxfun(@times, TF, IDF);  % tf-idf
A = A / max(A(:));


CANCER_CYCLES = 40;
k = 20;

realWorldExecute(runCan, runCanKL, runCap, runSnmf, runAls, runAlsr, ...
    runSvd, runNmfKL, A, k, CANCER_CYCLES, fileName, experName, runLat, runNMF, runLatTrunk, ...
    'runNmfJS', runNmfJS, 'runCanJS', runCanJS, 'LAT_ITERS', LAT_ITERS, 'only_runtime', only_runtime, ...
    'printing_option', printing_option, 'NITER_LATITUDE_PRINT', NITER_LATITUDE_PRINT);


end


