function CgenerateDimMixData(n, m, noise, density, minK, incK, itersK, nInstances, dataName, varargin)
onlyNMF = 0;
for i = 1 : numel(varargin)
    if isequal(varargin{i}, 'onlyNMF')
        onlyNMF = varargin{i+1};
    end
end

% Find dimentionality range.
dims = nan(itersK, 1);
for i = 1 : itersK
    dims(i) = minK + (i-1)*incK;
end

% Generate data.
for i = 1 : itersK
    for j = 1 : nInstances
        B = rand(n, dims(i));
        C = rand(dims(i), m);
        Bmask = rand(size(B)) < density;
        Cmask = rand(size(C)) < density;
        Borig{i}{j} = B .* Bmask;
        Corig{i}{j} = C .* Cmask;
        RANGE = 5;
        col{i}{j} = -RANGE + 2*RANGE*rand(n, 1);
        row{i}{j} = -RANGE + 2*RANGE*rand(1, m);
        if onlyNMF == 0
            Aorig{i}{j} = MixProd(Borig{i}{j}, Corig{i}{j}, col{i}{j}, row{i}{j});
        else
            Aorig{i}{j} = MixProdOnlyNMF(Borig{i}{j}, Corig{i}{j}, col{i}{j}, row{i}{j});
        end
        Anoisy{i}{j} = Aorig{i}{j};
        % Add noise.
        N = noise * randn(size(Aorig{i}{j}));
        Anoisy{i}{j} = max(0, Aorig{i}{j} + N);
    end
end

save(dataName, 'Aorig', 'Anoisy', 'Borig', 'Corig', 'col', 'row');

end

