function CgenerateNoiseData(n, m, k, density, minNoise, noiseInc, noiseIters, nInstances, dataName)
% Find densities range.
noiseLevels = nan(noiseIters, 1);
for i = 1 : noiseIters
    noiseLevels(i) = minNoise + (i-1)*noiseInc;
end

% Generate data.
for i = 1 : noiseIters
    for j = 1 : nInstances
        B = rand(n, k);
        C = rand(k, m);
        Bmask = rand(size(B)) < density;
        Cmask = rand(size(C)) < density;
        Borig{i}{j} = B .* Bmask;
        Corig{i}{j} = C .* Cmask;
        Aorig{i}{j} = MaxProduct(Borig{i}{j}, Corig{i}{j});
        % Add noise.
        N = noiseLevels(i) * randn(size(Aorig{i}{j}));
        Anoisy{i}{j} = max(0, Aorig{i}{j} + N);
    end
end

save(dataName, 'Aorig', 'Anoisy', 'Borig', 'Corig');

end

