function CrunCan(k, nIters, nInstances, dataName, fileName)
names = getTempNames(fileName, nIters);

%% Run algorithms for each param value.
load(dataName);
parfor i = 1 : nIters
    runInstances(names{i}, Anoisy{i}, nInstances, k);
end
% quit force

end


function runInstances(name, Anoisy, nInstances, k)

%% Load a partially completed temp file, or create a new one with dummy values.
if exist(name, 'file') > 0
    load(name);
else
    for j = 1 : nInstances
        B{j} = nan;  % Dummy values.
        C{j} = nan;
    end
    save(name, 'B', 'C');
end

%% Run algorithms.
for j = 1 : nInstances
    if isDummy(B{j}) || isDummy(C{j})
        [B{j}, C{j}] = Cancer(Anoisy{j}, k, 'parallel_exec', 1);
        if exist(name, 'file') > 0
            save(name, 'B', 'C', '-append');
        else
            save(name, 'B', 'C');
        end
    end
end
end