function CrunLat(k, nIters, nInstances, dataName, fileName)
names = getTempNames(fileName, nIters);

%% Run algorithms for each param value.
load(dataName);
didRun = zeros(nIters, 1);
parfor i = 1 : nIters
    didRun(i) = runInstances(names{i}, Anoisy{i}, nInstances, k);
end
% if sum(didRun) > 0
%     quit force
% end

end


function didRun = runInstances(name, Anoisy, nInstances, k)

%% Load a partially completed temp file, or create a new one with dummy values.
if exist(name, 'file') > 0
    load(name);
else
    for j = 1 : nInstances
        B{j} = nan;  % Dummy values.
        C{j} = nan;
        col{j} = nan;
        row{j} = nan;
    end
    save(name, 'B', 'C', 'col', 'row');
end

didRun = 0;
%% Run algorithms.
for j = 1 : nInstances
    if isDummy(B{j}) || isDummy(C{j})
        [B{j}, C{j}, col{j}, row{j}] = Latitude(Anoisy{j}, k);
        try
            if exist(name, 'file') > 0
                save(name, 'B', 'C', 'row', 'col', '-append');
            else
                save(name, 'B', 'C', 'row', 'col');
            end
        catch e
        end
        didRun = 1;
%         break;
    end
end
end