function dimOnlyNMFPart(varargin)
gen = 1;
action_ = 'plot';
if nargin > 0
    action_ = varargin{1};
end

% lockName = 'dimLock';
% if exist(lockName) > 0
%   return;
% end

rng('shuffle');
% setpath
% parpool

dataName = './data/synth/dimOnlyNMFPart';

canName = './results/synth/dimOnlyNMFPartCan.mat';
capName = './results/synth/dimOnlyNMFPartCap.mat';
snmfName = './results/synth/dimOnlyNMFPartSNMF.mat';
alsName = './results/synth/dimOnlyNMFPartALS.mat';
alsrName = './results/synth/dimOnlyNMFPartALSR.mat';
svdName = './results/synth/dimOnlyNMFPartSVD.mat';
alsr5Name = './results/synth/dimOnlyNMFPartALSR5.mat';
latName = './results/synth/dimOnlyNMFPartLat.mat';
nmfName = './results/synth/dimOnlyNMFPartNMF.mat';

saveName = './figs/dimOnlyNMFPart.pdf';
sparseName = './figs/dimOnlyNMFPartSparsity.pdf';

xlabelStr = 'k';
ylabelStr = 'Frobenius error';

addLegend = 0;

n = 1000;
m = 800;
noise = 0.01;
density = 0.5;
minK = 2;
incK = 2;
iters = 20;
nInstances = 10;

if strcmp(action_, 'run')
    if gen == 1
        CgenerateDimMixData(n, m, noise, density, minK, incK, iters, nInstances, dataName, 'onlyNMF', 1);
    else
%         CrunDimLat(minK, incK, iters, nInstances, dataName, latName);
%         combineAndDelete(latName, iters, nInstances, 'lat');
%         CrunDimSVD(minK, incK, iters, nInstances, dataName, svdName);
%         combineAndDelete(svdName, iters, nInstances, 'svd');
%         CrunDimNMF(minK, incK, iters, nInstances, dataName, nmfName);
%         combineAndDelete(nmfName, iters, nInstances, 'nmf');
        CrunDimCan(minK, incK, iters, nInstances, dataName, canName);
        combineAndDelete(canName, iters, nInstances, 'can');
        
        
        
        % % CrunDimCap(minK, incK, iters, nInstances, dataName, capName);
        % % combineAndDelete(capName, iters, nInstances, 'cap');
        %  CrunDimSnmf(minK, incK, iters, nInstances, dataName, snmfName, latName);
        %  combineAndDelete(snmfName, iters, nInstances, 'snmf');
        %  CrunDimAls(minK, incK, iters, nInstances, dataName, alsName);
        %  combineAndDelete(alsName, iters, nInstances, 'als');
        %  CrunDimAlsr(minK, incK, iters, nInstances, dataName, alsrName);
        %  combineAndDelete(alsrName, iters, nInstances, 'alsr');
        
        %  CrunDimAlsr5(minK, incK, iters, nInstances, dataName, alsr5Name);
        %  combineAndDelete(alsr5Name, iters, nInstances, 'alsr5');
    end
    % fid = fopen(lockName, 'wt' );
    % fprintf( fid, 'Do not rerun\n');
    % fclose(fid);
else
    Cplot(minK, incK, iters, nInstances, dataName, ...
        canName, capName, snmfName, alsName, alsrName, svdName, alsr5Name, latName, nmfName, ...
        saveName, sparseName, addLegend, xlabelStr, ylabelStr);
end

end


