function joinSynth(inDir1, inDir2, inDir3, outDir)
%% All directories (including outDir) must be different!

namesDir1 = dir(strcat(inDir1, '/*.mat'));
for i = 1 : numel(namesDir1)
    name = namesDir1(i).name;
    %% Append the first file.
    load(strcat(inDir1, '/', name));
    if exist('Bcan', 'var') > 0
        Bcan_ = Bcan;
        Ccan_ = Ccan;
    end
    if exist('Bcap', 'var') > 0
        Bcap_ = Bcap;
        Ccap_ = Ccap;
    end
    if exist('Bsnmf', 'var') > 0
        Bsnmf_ = Bsnmf;
        Csnmf_ = Csnmf;
    end
    if exist('Bals', 'var') > 0
        Bals_ = Bals;
        Cals_ = Cals;
    end
    if exist('Balsr', 'var') > 0
        Balsr_ = Balsr;
        Calsr_ = Calsr;
    end
    if exist('Bsvd', 'var') > 0
        Bsvd_ = Bsvd;
        Csvd_ = Csvd;
    end
    if exist('Anoisy', 'var') > 0
        Anoisy_ = Anoisy;
    end
    if exist('Aorig', 'var') > 0
        Aorig_ = Aorig;
    end
    if exist('Borig', 'var') > 0
        Borig_ = Borig;
    end
    if exist('Corig', 'var') > 0
        Corig_ = Corig;
    end
    
    
    %% Append the second file.
    load(strcat(inDir2, '/', name));
    if exist('Bcan', 'var') > 0
        Bcan_ = appendResults(Bcan_, Bcan);
        Ccan_ = appendResults(Ccan_, Ccan);
    end
    if exist('Bcap', 'var') > 0
        Bcap_ = appendResults(Bcap_, Bcap);
        Ccap_ = appendResults(Ccap_, Ccap);
    end
    if exist('Bsnmf', 'var') > 0
        Bsnmf_ = appendResults(Bsnmf_, Bsnmf);
        Csnmf_ = appendResults(Csnmf_, Csnmf);
    end
    if exist('Bals', 'var') > 0
        Bals_ = appendResults(Bals_, Bals);
        Cals_ = appendResults(Cals_, Cals);
    end
    if exist('Balsr', 'var') > 0
        Balsr_ = appendResults(Balsr_, Balsr);
        Calsr_ = appendResults(Calsr_, Calsr);
    end
    if exist('Bsvd', 'var') > 0
        Bsvd_ = appendResults(Bsvd_, Bsvd);
        Csvd_ = appendResults(Csvd_, Csvd);
    end
    if exist('Anoisy', 'var') > 0
        Anoisy_ = appendResults(Anoisy_, Anoisy);
    end
    if exist('Aorig', 'var') > 0
        Aorig_ = appendResults(Aorig_, Aorig);
    end
    if exist('Borig', 'var') > 0
        Borig_ = appendResults(Borig_, Borig);
    end
    if exist('Corig', 'var') > 0
        Corig_ = appendResults(Corig_, Corig);
    end
    
    
    %% Append the third file.
    load(strcat(inDir3, '/', name));
    if exist('Bcan', 'var') > 0
        Bcan_ = appendResults(Bcan_, Bcan);
        Ccan_ = appendResults(Ccan_, Ccan);
    end
    if exist('Bcap', 'var') > 0
        Bcap_ = appendResults(Bcap_, Bcap);
        Ccap_ = appendResults(Ccap_, Ccap);
    end
    if exist('Bsnmf', 'var') > 0
        Bsnmf_ = appendResults(Bsnmf_, Bsnmf);
        Csnmf_ = appendResults(Csnmf_, Csnmf);
    end
    if exist('Bals', 'var') > 0
        Bals_ = appendResults(Bals_, Bals);
        Cals_ = appendResults(Cals_, Cals);
    end
    if exist('Balsr', 'var') > 0
        Balsr_ = appendResults(Balsr_, Balsr);
        Calsr_ = appendResults(Calsr_, Calsr);
    end
    if exist('Bsvd', 'var') > 0
        Bsvd_ = appendResults(Bsvd_, Bsvd);
        Csvd_ = appendResults(Csvd_, Csvd);
    end
    if exist('Anoisy', 'var') > 0
        Anoisy_ = appendResults(Anoisy_, Anoisy);
    end
    if exist('Aorig', 'var') > 0
        Aorig_ = appendResults(Aorig_, Aorig);
    end
    if exist('Borig', 'var') > 0
        Borig_ = appendResults(Borig_, Borig);
    end
    if exist('Corig', 'var') > 0
        Corig_ = appendResults(Corig_, Corig);
    end
    
    
    %% Save results.
    if exist('Bcan', 'var') > 0
        Bcan = Bcan_;
        Ccan = Ccan_;
    end
    if exist('Bcap', 'var') > 0
        Bcap = Bcap_;
        Ccap = Ccap_;
    end
    if exist('Bsnmf', 'var') > 0
        Bsnmf = Bsnmf_;
        Csnmf = Csnmf_;
    end
    if exist('Bals', 'var') > 0
        Bals = Bals_;
        Cals = Cals_;
    end
    if exist('Balsr', 'var') > 0
        Balsr = Balsr_;
        Calsr = Calsr_;
    end
    if exist('Bsvd', 'var') > 0
        Bsvd = Bsvd_;
        Csvd = Csvd_;
    end
    if exist('Anoisy', 'var') > 0
        Anoisy = Anoisy_;
    end
    if exist('Aorig', 'var') > 0
        Aorig = Aorig_;
    end
    if exist('Borig', 'var') > 0
        Borig = Borig_;
    end
    if exist('Corig', 'var') > 0
        Corig = Corig_;
    end
    
    outFileName = strcat(outDir, '/', name);
    delete(outFileName);
    dummy = 1;
    save(outFileName, 'dummy');
    
    if exist('Bcan', 'var') > 0
        save(outFileName, 'Bcan', '-append');
        save(outFileName, 'Ccan', '-append');
    end
    if exist('Bcap', 'var') > 0
        save(outFileName, 'Bcap', '-append');
        save(outFileName, 'Ccap', '-append');
    end
    if exist('Bsnmf', 'var') > 0
        save(outFileName, 'Bsnmf', '-append');
        save(outFileName, 'Csnmf', '-append');
    end
    if exist('Bals', 'var') > 0
        save(outFileName, 'Bals', '-append');
        save(outFileName, 'Cals', '-append');
    end
    if exist('Balsr', 'var') > 0
        save(outFileName, 'Balsr', '-append');
        save(outFileName, 'Calsr', '-append');
    end
    if exist('Bsvd', 'var') > 0
        save(outFileName, 'Bsvd', '-append');
        save(outFileName, 'Csvd', '-append');
    end
    if exist('Anoisy', 'var') > 0
        save(outFileName, 'Anoisy', '-append');
    end
    if exist('Aorig', 'var') > 0
        save(outFileName, 'Aorig', '-append');
    end
    if exist('Borig', 'var') > 0
        save(outFileName, 'Borig', '-append');
    end
    if exist('Corig', 'var') > 0
        save(outFileName, 'Corig', '-append');
    end
    
    %% Clear temporary files.
    clear Bcan;
    clear Ccan;
    clear Bcap;
    clear Ccap;
    clear Bsnmf;
    clear Csnmf;
    clear Bals;
    clear Cals;
    clear Balsr;
    clear Calsr;
    clear Bsvd;
    clear Csvd;
    clear Anoisy;
    clear Aorig;
    clear Borig;
    clear Corig;
    
    clear Bcan_;
    clear Ccan_;
    clear Bcap_;
    clear Ccap_;
    clear Bsnmf_;
    clear Csnmf_;
    clear Bals_;
    clear Cals_;
    clear Balsr_;
    clear Calsr_;
    clear Bsvd_;
    clear Csvd_;
    clear Anoisy_;
    clear Aorig_;
    clear Borig_;
    clear Corig_;
end

end


function result = appendResults(var1, var2)
N = numel(var1);
for i = 1 : N
    result{i} = [var1{i}, var2{i}];
end
end