function varargout = worldclim(only_runtime, printing_option, NITER_LATITUDE_PRINT)
%% Load data.
dataName = './data/real/worldclim/worldclim.mat';
load(dataName);

%% Params
CANCER_CYCLES = 80;
LAT_ITERS = 100;
k = 10;

%% What algorithms to run.
runCan = 1;
runCanKL = 0;
runCap = 0;
runSnmf = 0;
runAls = 0;
runAlsr = 0;
runSvd = 1;
runNmfKL = 0;
runCanJS = 0;
runNmfJS = 0;
runLat = 1;
runNMF = 1;
runLatTrunk = 1;

fileName = './results/real/worldclim';
experName = 'worldclim';

%% Preprocess and save input data.
A = bsxfun(@minus, A, mean(A));
A = bsxfun(@rdivide, A, std(A));
A = bsxfun(@minus, A, min(A));
assert(min(min(A)) >= 0 );


%% Remove zero rows and columns.
idx = find(sum(A, 1) == 0);
if ~isempty(idx)
    A(:, idx) = [];
end
idx = find(sum(A, 2) == 0);
if ~isempty(idx)
    A(idx, :) = [];
end

realWorldExecute(runCan, runCanKL, runCap, runSnmf, runAls, runAlsr, ...
    runSvd, runNmfKL, A, k, CANCER_CYCLES, fileName, experName, runLat, runNMF, runLatTrunk, ...
    'runNmfJS', runNmfJS, 'runCanJS', runCanJS, 'LAT_ITERS', LAT_ITERS, 'only_runtime', only_runtime, ...
    'printing_option', printing_option, 'NITER_LATITUDE_PRINT', NITER_LATITUDE_PRINT);


end