function grad = relaxParamGrad(A, B, C, alpha)
[n, m] = size(A);
grad = nan(n, m);
for i = 1 : n
    for j = 1 : m
        grad(i, j) = getDerivative(A(i, j), B(i, :)'.*C(:,j), alpha(i,j));       
    end
end

end


function d = getDerivative(a, v, alpha)
phi = alpha .^ v;
psi = phi / sum(phi);
v_prod = sum(psi .* v);
deriv_gamma = nan(size(v));
for s = 1 : numel(v)
    p = v - v(s);
    deriv_gamma(s) = -1/(sum(alpha.^p))^2 * sum(p.*alpha.^(p-1));
end
deriv_v_prod = sum(v .* deriv_gamma);
d = 2 * (v_prod - a) * deriv_v_prod;
end