function [B, C] = nnmf_wrapper(A, k)
best_err = inf;
niter = 10;
[n, m] = size(A);
B = zeros(n, k);
C = zeros(k, m);
for iter = 1 : niter
    [B_, C_] = nnmf(A, k);
    err_ = norm(A - B_*C_, 'fro') / norm(A, 'fro');
    if err_ < best_err
        best_err = err_;
        B = B_;
        C = C_;
    end
end

end